#!/usr/bin/perl5

###########################################################################
#
# ENUM - Perl ENUM resolver module
#
# Copyright (c) 2004,2005  Japan Registry Services Co., LTD.
# Copyright (c) 2004,2005  Kazunori Fujiwara
# All Rights Reserved.
#
# Author: Kazunori Fujiwara <fujiwara@jprs.co.jp>
#
# This requires ENUM.pm <http://jprs.co.jp/enum/software/software.html>
#
###########################################################################

use strict;
use vars '$enumdomain';
use vars '$nameserver';
use vars '%supportservice';
use vars '$jphack';

$nameserver = 'sip.dnslab.jp';
$enumdomain = ".apenum.org.";
%supportservice = (
	'tel' => 1,
	'sip' => 1,
	'h323' => 1,
	'email:mailto' => 1,
	'web:http' => 1,
	'web:https' => 1,
);
$jphack = 1;

use Net::DNS;

use ENUM;

sub CGI
{
	my ($n, $AUTHINFO, $cgidebug, $AUS, @ret, $uri);

	print "Content-type: text/html\n\n";

	print "ENUM web client<BR /><BR />\n";
	$AUS = '';

	my $REQUEST_METHOD = $ENV{'REQUEST_METHOD'};
	my $CLIENT = $ENV{'REMOTE_ADDR'};
	my $USER = '';
	my $PASSWD = '';
	my $LOGOUT = '';

	if ($REQUEST_METHOD eq "POST") {
		$n=read( STDIN, $AUTHINFO, $ENV{'CONTENT_LENGTH'} );
		# user=a&passwd=b&logout=1
	} elsif ($REQUEST_METHOD eq "GET") {
		# REQUEST_URI = /cgi-bin/auth.pl?user=a&passwd=b
		($n, $AUTHINFO) = split(/\?/, $ENV{'REQUEST_URI'}, 2);
		#print "Invalid input:REQUEST_URI=$ENV{REQUEST_URI}\n"; exit;
	} else {
		print "Invalid input:REQUEST_METHOD=$REQUEST_METHOD\n"; exit;
	}
	
	foreach my $lines (split(/&/, $AUTHINFO)) {
		my ($key, $val) = split(/=/, $lines, 2);
		$key =~ s/%3[aA]/:/;
		if ($key eq 'debug') {
			$cgidebug = $val;
		} elsif ($key eq 'no') {
			$AUS = $val;
			$AUS =~ s/^%2B/\+/;
		} else {
			print "unknown cgi line \"$key=$val\"<BR />\n";
		}
	}

	$AUS = &AUScheck($AUS);
	my $resolver= Net::DNS::Resolver->new;
	$resolver->nameservers($nameserver);
	print "AUS=$AUS<BR /><BR />\n";
	@ret = &EnumQuery($AUS, $enumdomain, $resolver, %supportservice);

	if ($ENUM::enumerror ne "") {
		$ENUM::enumerror =~ s/\n/<BR>\n/g;
		print $ENUM::enumerror, "<BR>\n";
	}
	if (scalar(@ret) == 0) {
		print "no data matched<BR>\n";
	} else {
		foreach my $r (@ret) {
			$uri = $r->{uri};
			$uri =~ s/^tel:\+81/tel:0/i if ($jphack);
			print $r->{pref}," ", $r->{servicefound}, 
				" <a href=\"", $uri, "\">", $r->{uri},
				"</a><br>\n";
		}
	}
	exit 0;
};

&CGI;

